//Groovy functional pipeline is eager
//Java functional pipeline is lazy
//Kotlin gives you a choice

fun check(number: Int): Boolean {
  println("check called for $number")
  return number % 2 == 0
}

fun double(number: Int): Int {
  println("double called for $number")
  return number * 2
}

val numbers = listOf(1, 2, 3, 4, 5, 6)

//eager evaluation
val result1 = numbers
   .filter(::check)
   .map(::double)
  .first()

println(result1)

println("--------")

//lazy evaluation
val result2 = numbers
   .asSequence()
   .filter(::check)
   .map(::double)
  .first()

println(result2)

